Attribute VB_Name = "SmallSubs"
Option Explicit


'----------------------------------------------------------------
' MAIN

Public Sub Main()
  Dim I As Integer
  
  ' Get the path where files are could
  DATAPATH = App.Path
  If Not Right(DATAPATH, 1) = "\" Then DATAPATH = DATAPATH + "\"
  
  ' Load in the pictures
  On Error Resume Next
    For I = 0 To OBJECT_IMAGES - 1
      Set Game.Object(I) = LoadPicture(DATAPATH & "Pictures\Object" & I & ".bmp")
    Next
    For I = 0 To PLAYER_IMAGES - 1
      Set Game.Player(I) = LoadPicture(DATAPATH & "Pictures\Player" & I & ".bmp")
    Next
  On Error GoTo 0
  
  ' Show a sample level
  Game.PlayerStyle = WALKLEFT
  Call ClearLevel(False)
  
  ' Show the main window
  Load frmMain
  frmMain.Show
End Sub


'----------------------------------------------------------------
' Exits the program

Public Function ExitProgram() As Boolean
  Dim I As Integer
  Set ActiveForm = Nothing
  
  For I = Forms.Count - 1 To 0 Step -1
    Unload Forms(I)
  Next
End Function


'----------------------------------------------------------------
' Utilities

Public Function FileExist(FileName As String) As Boolean
  ' Does a file exist?
  FileExist = Len(Dir(FileName)) > 0 And Len(FileName) > 0
End Function

Public Function FormatDialogFile(FileName As String) As String
  FormatDialogFile = FileName
  FormatDialogFile = Replace(FormatDialogFile, "*", "x")
  FormatDialogFile = Replace(FormatDialogFile, "?", "!")
  FormatDialogFile = Replace(FormatDialogFile, "/", " ")
  FormatDialogFile = Replace(FormatDialogFile, "\", " ")
  FormatDialogFile = Replace(FormatDialogFile, ":", "-")
  FormatDialogFile = Replace(FormatDialogFile, "|", "")
  FormatDialogFile = Replace(FormatDialogFile, "<", "")
  FormatDialogFile = Replace(FormatDialogFile, ">", "")
  FormatDialogFile = Replace(FormatDialogFile, """", "'")
End Function


Public Function Min(Val1 As Integer, Val2 As Integer) As Integer
  ' Least of two values
  If Val1 < Val2 Then
    Min = Val1
  Else
    Min = Val2
  End If
End Function

Public Function KeyIsNumber(KeyCode As Integer) As Boolean
  ' Is the key a number?
  Select Case KeyCode
    Case vbKey0 To vbKey9: KeyIsNumber = True: Exit Function
    Case vbKeyBack: KeyIsNumber = True: Exit Function
    Case vbKeyDelete: KeyIsNumber = True: Exit Function
    Case vbKeyLeft: KeyIsNumber = True: Exit Function
    Case vbKeyRight: KeyIsNumber = True: Exit Function
    Case vbKeyUp: KeyIsNumber = True: Exit Function
    Case vbKeyDown: KeyIsNumber = True: Exit Function
    Case vbKeyShift: KeyIsNumber = True: Exit Function
    Case vbKeyControl: KeyIsNumber = True: Exit Function
    Case vbKeyMenu: KeyIsNumber = True: Exit Function
  End Select
  KeyIsNumber = False
End Function



